    001    /* ========================================================================
    002     * JCommon : a free general purpose class library for the Java(tm) platform
    003     * ========================================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jcommon/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------------
    028     * IntegerDocument.java
    029     * --------------------
    030     * (C) Copyright 2000-2004, by Andrzej Porebski.
    031     *
    032     * Original Author:  Andrzej Porebski;
    033     * Contributor(s):   -;
    034     *
    035     * $Id: IntegerDocument.java,v 1.2 2005/10/18 13:18:34 mungady Exp $
    036     *
    037     * Changes (from 7-Nov-2001)
    038     * -------------------------
    039     * 07-Nov-2001 : Added to com.jrefinery.ui package (DG);
    040     * 14-Oct-2002 : Fixed errors reported by Checkstyle (DG);
    041     *
    042     */
    043
    044    package org.jfree.ui;
    045
    046    import javax.swing.text.AttributeSet;
    047    import javax.swing.text.BadLocationException;
    048    import javax.swing.text.PlainDocument;
    049
    050    /**
    051     * A document for editing integers.
    052     *
    053     * @author Andrzej Porebski
    054     */
    055    public class IntegerDocument extends PlainDocument {
    056
    057        /**
    058         * Inserts a string.
    059         *
    060         * @param i  i.
    061         * @param s  s.
    062         * @param attributes  the attributes.
    063         *
    064         * @throws BadLocationException ??
    065         */
    066        public void insertString(final int i, final String s, final AttributeSet attributes)
    067            throws BadLocationException {
    068
    069            super.insertString(i, s, attributes);
    070            if (s != null && (!s.equals("-") || i != 0 || s.length() >= 2)) {
    071                try {
    072                    Integer.parseInt(getText(0, getLength()));
    073                }
    074                catch (NumberFormatException e) {
    075                    remove(i, s.length());
    076                }
    077            }
    078        }
    079
    080    }